Index: trunk/SophyaLib/BaseTools/Makefile
===================================================================
--- trunk/SophyaLib/BaseTools/Makefile	(revision 1241)
+++ trunk/SophyaLib/BaseTools/Makefile	(revision 1242)
@@ -3,7 +3,7 @@
 all: $(LIB)libSysTools.a
 clean:
-	rm -f $(OBJ)ctimer.o $(OBJ)datacards.o $(OBJ)datatype.o $(OBJ)dvlist.o $(OBJ)fiondblock.o $(OBJ)mutyv.o $(OBJ)ndatablock.o $(OBJ)pdlmgr.o $(OBJ)periodic.o $(OBJ)pexceptions.o $(OBJ)ppersist.o $(OBJ)psighand.o $(OBJ)sophyainit.o $(OBJ)utils.o $(OBJ)gnumd5.o $(OBJ)srandgen.o $(OBJ)strutil.o $(OBJ)timing.o
+	rm -f $(OBJ)ctimer.o $(OBJ)datacards.o $(OBJ)datatype.o $(OBJ)dvlist.o $(OBJ)fiondblock.o $(OBJ)mutyv.o $(OBJ)ndatablock.o $(OBJ)pdlmgr.o $(OBJ)periodic.o $(OBJ)pexceptions.o $(OBJ)ppersist.o $(OBJ)psighand.o $(OBJ)sophyainit.o $(OBJ)strutilxx.o $(OBJ)utils.o $(OBJ)gnumd5.o $(OBJ)srandgen.o $(OBJ)strutil.o $(OBJ)timing.o
 	rm -f $(LIB)libSysTools.a
-$(LIB)libSysTools.a : $(OBJ)ctimer.o $(OBJ)datacards.o $(OBJ)datatype.o $(OBJ)dvlist.o $(OBJ)fiondblock.o $(OBJ)gnumd5.o $(OBJ)mutyv.o $(OBJ)ndatablock.o $(OBJ)pdlmgr.o $(OBJ)periodic.o $(OBJ)pexceptions.o $(OBJ)ppersist.o $(OBJ)psighand.o $(OBJ)sophyainit.o $(OBJ)srandgen.o $(OBJ)strutil.o $(OBJ)timing.o $(OBJ)utils.o
+$(LIB)libSysTools.a : $(OBJ)ctimer.o $(OBJ)datacards.o $(OBJ)datatype.o $(OBJ)dvlist.o $(OBJ)fiondblock.o $(OBJ)gnumd5.o $(OBJ)mutyv.o $(OBJ)ndatablock.o $(OBJ)pdlmgr.o $(OBJ)periodic.o $(OBJ)pexceptions.o $(OBJ)ppersist.o $(OBJ)psighand.o $(OBJ)sophyainit.o $(OBJ)srandgen.o $(OBJ)strutil.o $(OBJ)strutilxx.o $(OBJ)timing.o $(OBJ)utils.o
 	$(ARCXX) $(ARCXXFLAGS) $@ $?
 ifeq ($(CXX),cxx)
@@ -30,4 +30,5 @@
  ppersist.h gnumd5.h fiondblock.h ndatablock.h anydataobj.h dvlist.h \
  objfio.h mutyv.h sversion.h
+$(OBJ)strutilxx.o: strutilxx.cc machdefs.h strutilxx.h
 $(OBJ)utils.o: utils.cc machdefs.h utils.h pexceptions.h
 $(OBJ)gnumd5.o: gnumd5.c machdefs.h bithelp.h gnumd5.h
Index: trunk/SophyaLib/NTools/Makefile
===================================================================
--- trunk/SophyaLib/NTools/Makefile	(revision 1241)
+++ trunk/SophyaLib/NTools/Makefile	(revision 1242)
@@ -11,6 +11,5 @@
 endif 
  
-$(OBJ)cimage.o: cimage.cc \
- $(INC)machdefs.h \
+$(OBJ)cimage.o: cimage.cc $(INC)machdefs.h \
  $(INC)pexceptions.h cimage.h \
  $(INC)tmatrix.h \
@@ -24,16 +23,15 @@
  $(INC)gnumd5.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h
-$(OBJ)cspline.o: cspline.cc \
- $(INC)machdefs.h nbtri.h \
- cspline.h $(INC)pexceptions.h
+ $(INC)utilarr.h \
+ $(INC)fioarr.h \
+ $(INC)tvector.h
+$(OBJ)cspline.o: cspline.cc $(INC)machdefs.h \
+ nbtri.h cspline.h $(INC)pexceptions.h
 $(OBJ)datatypes.o: datatypes.cc datatypes.h \
  $(INC)machdefs.h
-$(OBJ)dates.o: dates.cc \
- $(INC)machdefs.h \
+$(OBJ)dates.o: dates.cc $(INC)machdefs.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h dates.h
-$(OBJ)difeq.o: difeq.cc difeq.h \
- $(INC)machdefs.h \
+$(OBJ)difeq.o: difeq.cc difeq.h $(INC)machdefs.h \
  $(INC)pexceptions.h \
  $(INC)tvector.h \
@@ -50,6 +48,5 @@
  $(INC)utilarr.h \
  $(INC)ctimer.h
-$(OBJ)dynccd.o: dynccd.cc \
- $(INC)machdefs.h fmath.h \
+$(OBJ)dynccd.o: dynccd.cc $(INC)machdefs.h fmath.h \
  perandom.h $(INC)histos.h \
  $(INC)objfio.h \
@@ -71,43 +68,38 @@
  $(INC)utilarr.h nbrandom.h \
  $(INC)srandgen.h cimage.h \
- dynccd.h
-$(OBJ)fct1dfit.o: fct1dfit.cc \
- $(INC)machdefs.h fct1dfit.h \
- generalfit.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h poly.h peida.h \
- $(INC)utils.h \
- $(INC)perrors.h fmath.h \
- nbconst.h tabmath.h
-$(OBJ)fct2dfit.o: fct2dfit.cc \
- $(INC)machdefs.h fct2dfit.h \
- generalfit.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h poly.h peida.h \
- $(INC)utils.h \
- $(INC)perrors.h fmath.h \
- nbconst.h tabmath.h simps2d.h
+ $(INC)fioarr.h dynccd.h
+$(OBJ)fct1dfit.o: fct1dfit.cc $(INC)machdefs.h \
+ fct1dfit.h generalfit.h $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h $(INC)utils.h \
+ $(INC)perrors.h fmath.h nbconst.h tabmath.h
+$(OBJ)fct2dfit.o: fct2dfit.cc $(INC)machdefs.h \
+ fct2dfit.h generalfit.h $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h $(INC)utils.h \
+ $(INC)perrors.h fmath.h nbconst.h tabmath.h \
+ simps2d.h
 $(OBJ)fftmserver.o: fftmserver.cc fftmserver.h fftservintf.h \
  $(INC)machdefs.h \
@@ -172,23 +164,21 @@
 $(OBJ)generaldata.o: generaldata.cc \
  $(INC)machdefs.h \
- $(INC)strutil.h nbtri.h \
- generalfit.h $(INC)pexceptions.h \
- $(INC)tvector.h \
- $(INC)tmatrix.h \
- $(INC)tarray.h \
- $(INC)basarr.h \
- $(INC)anydataobj.h \
- $(INC)mutyv.h \
- $(INC)dvlist.h \
- $(INC)objfio.h \
- $(INC)ppersist.h \
- $(INC)gnumd5.h \
- $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h poly.h peida.h \
- $(INC)utils.h \
+ $(INC)strutil.h nbtri.h generalfit.h \
+ $(INC)pexceptions.h \
+ $(INC)tvector.h \
+ $(INC)tmatrix.h \
+ $(INC)tarray.h \
+ $(INC)basarr.h \
+ $(INC)anydataobj.h \
+ $(INC)mutyv.h \
+ $(INC)dvlist.h \
+ $(INC)objfio.h \
+ $(INC)ppersist.h \
+ $(INC)gnumd5.h \
+ $(INC)ndatablock.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h $(INC)utils.h \
  $(INC)perrors.h fmath.h
-$(OBJ)generalfit.o: generalfit.cc \
- $(INC)machdefs.h \
+$(OBJ)generalfit.o: generalfit.cc $(INC)machdefs.h \
  $(INC)pexceptions.h generalfit.h \
  $(INC)tvector.h \
@@ -203,11 +193,9 @@
  $(INC)gnumd5.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h poly.h peida.h \
- $(INC)utils.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h $(INC)utils.h \
  $(INC)perrors.h fmath.h \
  $(INC)sopemtx.h
-$(OBJ)integ.o: integ.cc integ.h \
- $(INC)machdefs.h \
+$(OBJ)integ.o: integ.cc integ.h $(INC)machdefs.h \
  $(INC)pexceptions.h generalfit.h \
  $(INC)tvector.h \
@@ -222,12 +210,10 @@
  $(INC)gnumd5.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h poly.h peida.h \
- $(INC)utils.h \
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ poly.h peida.h $(INC)utils.h \
  $(INC)perrors.h fmath.h
 $(OBJ)median.o: median.cc
-$(OBJ)ntoolsinit.o: ntoolsinit.cc \
- $(INC)machdefs.h ntoolsinit.h \
- $(INC)tarrinit.h \
+$(OBJ)ntoolsinit.o: ntoolsinit.cc $(INC)machdefs.h \
+ ntoolsinit.h $(INC)tarrinit.h \
  $(INC)sophyainit.h poly.h \
  $(INC)objfio.h \
@@ -245,6 +231,7 @@
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h generaldata.h \
- ntupintf.h cimage.h tabmath.h nbconst.h dates.h datime.h
+ $(INC)utilarr.h generaldata.h ntupintf.h \
+ cimage.h $(INC)fioarr.h tabmath.h nbconst.h \
+ dates.h datime.h
 $(OBJ)ntupintf.o: ntupintf.cc ntupintf.h \
  $(INC)machdefs.h
@@ -262,5 +249,6 @@
  $(INC)gnumd5.h \
  $(INC)ndatablock.h \
- $(INC)utilarr.h \
+ $(INC)utilarr.h cimage.h \
+ $(INC)fioarr.h \
  $(INC)tvector.h \
  $(INC)histos.h \
@@ -270,8 +258,7 @@
  $(INC)fmath.h \
  $(INC)histos2.h \
- $(INC)hisprof.h generalfit.h \
- generaldata.h ntupintf.h poly.h peida.h
-$(OBJ)perandom.o: perandom.cc \
- $(INC)machdefs.h \
+ $(INC)hisprof.h generalfit.h generaldata.h \
+ ntupintf.h poly.h peida.h
+$(OBJ)perandom.o: perandom.cc $(INC)machdefs.h \
  $(INC)pexceptions.h perandom.h \
  $(INC)histos.h \
@@ -293,6 +280,6 @@
  $(INC)utilarr.h nbrandom.h \
  $(INC)srandgen.h pemath.h
-$(OBJ)poly.o: poly.cc $(INC)machdefs.h \
- poly.h $(INC)objfio.h \
+$(OBJ)poly.o: poly.cc $(INC)machdefs.h poly.h \
+ $(INC)objfio.h \
  $(INC)anydataobj.h \
  $(INC)ppersist.h \
@@ -311,7 +298,6 @@
  $(INC)sopemtx.h \
  $(INC)fioarr.h
-$(OBJ)rk4cdifeq.o: rk4cdifeq.cc \
- $(INC)machdefs.h rk4cdifeq.h \
- difeq.h $(INC)pexceptions.h \
+$(OBJ)rk4cdifeq.o: rk4cdifeq.cc $(INC)machdefs.h \
+ rk4cdifeq.h difeq.h $(INC)pexceptions.h \
  $(INC)tvector.h \
  $(INC)tmatrix.h \
@@ -327,19 +313,14 @@
  $(INC)utilarr.h \
  $(INC)ctimer.h
-$(OBJ)simplesort.o: simplesort.cc \
- $(INC)machdefs.h simplesort.h \
- peida.h $(INC)utils.h \
+$(OBJ)simplesort.o: simplesort.cc $(INC)machdefs.h \
+ simplesort.h peida.h $(INC)utils.h \
  $(INC)perrors.h \
  $(INC)pexceptions.h fmath.h
-$(OBJ)tabmath.o: tabmath.cc \
- $(INC)machdefs.h tabmath.h \
- peida.h $(INC)utils.h \
- $(INC)perrors.h \
- $(INC)pexceptions.h fmath.h \
- nbconst.h
-$(OBJ)datime.o: datime.c \
- $(INC)machdefs.h \
- $(INC)strutil.h nbconst.h \
- datime.h
+$(OBJ)tabmath.o: tabmath.cc $(INC)machdefs.h \
+ tabmath.h peida.h $(INC)utils.h \
+ $(INC)perrors.h \
+ $(INC)pexceptions.h fmath.h nbconst.h
+$(OBJ)datime.o: datime.c $(INC)machdefs.h \
+ $(INC)strutil.h nbconst.h datime.h
 $(OBJ)fftmayer_r4.o: fftmayer_r4.c fftmayer.h \
  $(INC)machdefs.h trigtbl.h
@@ -351,8 +332,6 @@
  $(INC)machdefs.h \
  $(INC)smathconst.h
-$(OBJ)nbmath.o: nbmath.c nbmath.h \
- $(INC)machdefs.h \
- $(INC)smathconst.h matxop.h \
- nbinteg.h nbtri.h
-$(OBJ)nbtri.o: nbtri.c nbtri.h \
- $(INC)machdefs.h
+$(OBJ)nbmath.o: nbmath.c nbmath.h $(INC)machdefs.h \
+ $(INC)smathconst.h matxop.h nbinteg.h \
+ nbtri.h
+$(OBJ)nbtri.o: nbtri.c nbtri.h $(INC)machdefs.h
Index: trunk/SophyaLib/SkyMap/Makefile
===================================================================
--- trunk/SophyaLib/SkyMap/Makefile	(revision 1241)
+++ trunk/SophyaLib/SkyMap/Makefile	(revision 1242)
@@ -62,5 +62,5 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h spherehealpix.h \
- $(INC)fiondblock.h
+ HEALPixUtils.h $(INC)fiondblock.h
 $(OBJ)fiospherethetaphi.o: fiospherethetaphi.cc fiospherethetaphi.h \
  sphericalmap.h $(INC)smathconst.h \
@@ -130,5 +130,6 @@
  $(INC)ndatablock.h \
  $(INC)utilarr.h fiospherehealpix.h \
- spherehealpix.h fiospherethetaphi.h fiolocalmap.h localmap.h
+ spherehealpix.h HEALPixUtils.h fiospherethetaphi.h fiolocalmap.h \
+ localmap.h
 $(OBJ)spherehealpix.o: spherehealpix.cc \
  $(INC)machdefs.h \
@@ -148,6 +149,6 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
- $(INC)utilarr.h \
- $(INC)strutil.h HEALPixUtils.h
+ $(INC)utilarr.h HEALPixUtils.h \
+ $(INC)strutil.h
 $(OBJ)spherepos.o: spherepos.cc spherepos.h \
  $(INC)machdefs.h \
Index: trunk/SophyaLib/SkyT/Makefile
===================================================================
--- trunk/SophyaLib/SkyT/Makefile	(revision 1241)
+++ trunk/SophyaLib/SkyT/Makefile	(revision 1242)
@@ -58,4 +58,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -75,4 +76,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)ndatablock.h \
@@ -87,4 +89,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \
@@ -100,4 +103,5 @@
  $(INC)tarray.h \
  $(INC)basarr.h \
+ $(INC)mutyv.h \
  $(INC)dvlist.h \
  $(INC)objfio.h \